import PageRecord from '../../structures/PageRecord';

export abstract class EditorNodeContract {
    protected pageRec!: PageRecord;
    protected nodeRec!: any; // TODO
    protected initialValue: any;

    get page() {
        return this.pageRec;
    }

    set page(page: PageRecord) {
        this.pageRec = page;
    }

    get identifier() {
        return this.nodeRec.UUID;
    }

    public abstract isDirty(): boolean | Promise<boolean>;

    public needsSave(): boolean | Promise<boolean> {
        return false;
    }

    public needsLoad(): boolean | Promise<boolean> {
        return false;
    }

    public performSave(): void | Promise<void> {}

    public performLoad(): void | Promise<void> {}
}
